//+------------------------------------------------------------------+
//|                                             "Master_MM_Droid.mq4"|
//|        2.4  http://codebase.mql4.com |
//|                              Copyright  2013, Musa Esmagambetov |
//|                                                   cocaine@nxt.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Musa Esmagambetov"
#property link      "cocaine@nxt.ru"
//+------------------------------------------------------------------+
//    ():
#define mm_math_sqrt       1                  //    
#define mm_percent         2                  //  
#define mm_martingale      3                  // 
#define mm_antimartingale  4                  // 
#define mm_rajan_jones     5                  //   
#define mm_larry_williams  6                  //   
#define mm_second_chance   7                  //  ( )
#define mm_f2stop          8                  // 2%
#define mm_test            9                  //     
//+------------------------------------------------------------------+
//extern int mm_user_mode = 1;   //   
//+------------------------------------------------------------------+
extern int time_shift = 2;       //     GMT
int start_hour = 0;              // 
//+------------------------------------------------------------------+
extern int mm_rsi_mode = 1;                 //    "RSI"
extern int mm_boxes_mode = 1;               //    " "
extern int mm_weekly_mode = 1;              //    " "
extern int mm_gap_mode = 1;                 //    " "
//+------------------------------------------------------------------+
string mm_names[] ={" ,   ","20%    ",
"  ","","","  ","  "," ( )",
"2 ",""};
 
//     ,     
int martingale_count=1, antimartingale_count=0, rajan_jones_count = 0;
//+------------------------------------------------------------------+
double risk = 0.05;              //           
double delta = 500;              //       
//+------------------------------------------------------------------+
double start_virtual_balance[4]; //      
//+------------------------------------------------------------------+
double rajan_jones_level;        //       
double martingale_balance;       //    
double antimartingale_balance;   //    
double virtual_deposit;          // ,        
double balance_separator = 0.25; //    4 
//+------------------------------------------------------------------+
#define rsi_magic    50          //      "RSI"
#define boxes_magic  35          //      " "
#define weekly_magic 100         //      " "
#define gap_magic    115         //      " "
//+------------------------------------------------------------------+
int orders_limit = 3;            //    "RSI"
int dif = 15;                    //     "RSI"
double min_lot = 0.1;            // ,    ,   !
//+-------------------------- ----------------------------------------+
#define sell_signal        -11    //  
#define buy_signal          11    //  
#define no_signal           0     //  ,  
#define close_buy           22    //   
#define close_sell         -22    //   
#define error_signal        33    //   
#define clear_signal        44    //   
#define set_stops           55    //     
#define weekly_open         66    //     
#define weekly_close        77    //       
#define gap_clear           88    //   
#define gap_open            99    //     
//+------------------------------------------------------------------+      
string   comment         = "Master_MM_Droid, v 2.4"; //  
int      error_number = 0;    // 
int      rsi_sl = 35;         //   "RSI"
int      ts_step   = 5;       // 
//+------------------------------------------------------------------+
int slippage = 5;       //
int magics[4];          //  
int enter = 6;          //          
int weekly_enter = 15;  //          
int gap_stop = 105;            //    
//-----------------------      
bool ts_rsi_on = true; 
bool ts_weekly_on = true;
bool ts_gap_on = true; 
bool ts_box_on = true;
//-----------------------
string symbol;
int rebalance_index[] = {0, 0, 0, 0};
//----------------------- 
void init()
{
symbol = Symbol();

      magics[0] = rsi_magic;
      magics[1] = boxes_magic; 
      magics[2] = weekly_magic; 
      magics[3] = gap_magic;
      
 if (Digits == 5 || Digits == 3)
   {
      gap_stop *= 10;
      enter   *= 10;
      slippage *= 10;
      ts_step  *= 10;
      rsi_sl   *= 10; 
      weekly_enter   *= 10; 
      dif    *= 10;
   }

   if (balance_separator == 0)
      {
      balance_separator = 1;
      }
   else
      {
      double t_blnc = balance_separator*AccountBalance();
      rajan_jones_level = t_blnc;
      martingale_balance = t_blnc;
      antimartingale_balance = t_blnc;
      virtual_deposit = t_blnc;
//+------------------------------------------------------------------+      
      start_virtual_balance[0] = t_blnc;
      start_virtual_balance[1] = t_blnc;
      start_virtual_balance[2] = t_blnc;
      start_virtual_balance[3] = t_blnc;
      }
      min_lot = MathMax(NormalizeDouble(virtual_deposit/100000,2), MarketInfo(Symbol(), MODE_MINLOT));
      
   return (0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{        
info();
         
return(0);
}
//----------------------- 
int start(){
   if (IsTradeAllowed()==false || Volume[0]>1) return (0);
   for(int main_count=0; main_count < 4; main_count++){
   int magic_number = magics[main_count];
      switch(scan_market(symbol, magic_number))
            {
      case sell_signal:
            if (ts_rsi_on == true)
            sell_routine(mm_rsi_mode, symbol, magic_number, rsi_sl);
            break;
      case buy_signal:
            if (ts_rsi_on == true)
            buy_routine(mm_rsi_mode, symbol, magic_number, rsi_sl); 
            break;
      case clear_signal:
            close_all(symbol, magic_number);    
            break;
      case set_stops:
            if (ts_box_on == true)
            set_stop_orders(mm_boxes_mode, symbol, magic_number);
            break;
      case weekly_open: 
            if (ts_weekly_on == true)
            weekly_orders(mm_weekly_mode, symbol, magic_number); 
            break;
      case weekly_close: 
            close_all(symbol, magic_number);    
            break;
      case gap_clear: 
            close_all(symbol, magic_number);
            break;
      case gap_open:
            if (ts_gap_on == true)
            gap_weekly(mm_gap_mode, symbol, magic_number);
            break;
      case no_signal: 
            trailing(symbol, magic_number); 
            break;
      case error_signal: 
            Print(error_func(error_number));
            error_number = 0;
            break;
            }
         }   
return (0);}
//----------------------- 
void trailing(string symbol, int mn)
{
   int ts = mn;
   if(Digits == 5 || Digits == 3) ts *= 10;
   
while(!IsTradeAllowed()) Sleep(100);
for (int i=OrdersTotal()-1; i>=0; i--)
if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol() == symbol && OrderMagicNumber()==mn) trail_order(OrderTicket(), ts);
return;
}
//----------------------- 
void trail_order(int ticket, int treil_stop)
{ 
 if(OrderType()==OP_BUY && Bid-treil_stop*Point>OrderStopLoss()+ts_step*Point) 
 trail_routine(OrderTicket(), NormalizeDouble(Bid-treil_stop*Point,Digits));
 if(OrderType()==OP_SELL && Ask+treil_stop*Point<OrderStopLoss()-ts_step*Point) 
 trail_routine(OrderTicket(), NormalizeDouble(Ask+treil_stop*Point,Digits));
}
//----------------------- 
void trail_routine(int ticket, double price)
{
int count = 0; 
 if(OrderSelect(ticket,SELECT_BY_TICKET))     
     while(OrderModify(ticket,OrderOpenPrice(),price,0,0,CLR_NONE) == false)
     {
     Sleep(30000); RefreshRates();count++; 
     if(count > 5) break;
     }  
return;
}
//-----------------------  
void close_all(string symbol, int mn){

for(int i=OrdersTotal()-1;i>=0;i--)
if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol() == symbol && OrderMagicNumber()==mn) close_order(OrderTicket());
return;
}
//+------------------------------------------------------------------+
//   
void close_order(int ticket)
{
double price = 0;
bool temp = false;
int count = 0;
 while(!IsTradeAllowed()) Sleep(100);
 if(OrderType()==OP_BUY)  price = NormalizeDouble(Bid,Digits);
 if(OrderType()==OP_SELL) price = NormalizeDouble(Ask,Digits);
 if(OrderSelect(ticket,SELECT_BY_TICKET))
     while(temp == false)
     {
     if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP) temp = OrderDelete(ticket); 
     else temp = OrderClose(ticket,OrderLots(),price,slippage,CLR_NONE);
     Sleep(30000); RefreshRates();count++; 
     if(count > 5) break;
     }  
return;
}
//----------------------- 
int calculate_orders(string symbol, int cmd, int mn) 
{
   int count = 0;
   for(int trade = OrdersTotal() - 1; trade >= 0; trade--) 
   {
      OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol() == symbol && OrderMagicNumber() == mn && OrderType() == cmd) count++;
   }
   return (count);
}
//----------------------- 
int scan_market(string symbol, int magic){
error_number = GetLastError();
   if(error_number!=0) return (error_signal);   
    int b_orders = calculate_orders(symbol, OP_BUY, magic);
    int s_orders = calculate_orders(symbol, OP_SELL, magic);
    //int t_orders = trade_orders(symbol, magic);
    int t_orders = s_orders + b_orders;
    int st_orders = stop_orders(symbol, magic);
 
switch(magic){
case rsi_magic:
//-----------------------          
     double open_price = 0;
     double r1 = iRSI(NULL,0,14,PRICE_CLOSE,1);
     double r2 = iRSI(NULL,0,14,PRICE_CLOSE,2);
//-----------------------          
     for(int t = 0; t < OrdersTotal(); t++) 
      {
      OrderSelect(t, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol() == symbol && OrderMagicNumber() == rsi_magic)
      open_price = OrderOpenPrice();
      }
//-----------------------       
     if((r2 < 30 && r1 > 30 && b_orders == 0) || (b_orders > 0 && b_orders < orders_limit && Bid > open_price + dif*Point))
      return (buy_signal);  
//-----------------------       
     if((r2 > 70 && r1 < 70 && s_orders == 0) || (s_orders > 0 && s_orders < orders_limit && Ask < open_price - dif*Point))
      return (sell_signal);  
      break;
case boxes_magic:
//-----------------------    
   if(TimeHour(TimeCurrent()) == (0 + time_shift) || 
   TimeHour(TimeCurrent()) == (10 + time_shift) || 
   TimeHour(TimeCurrent()) == (16 + time_shift))
      return (clear_signal);      
   if((TimeHour(TimeCurrent()) == (6 + time_shift) || 
   TimeHour(TimeCurrent()) == (12 + time_shift) || 
    TimeHour(TimeCurrent()) == (20 + time_shift)) && st_orders == 0)
      return (set_stops);                 
//-----------------------      
      break;
case weekly_magic:
//-----------------------          
            if(DayOfWeek() == 1 && Hour() > (start_hour + time_shift) && Hour() < (6 + time_shift) && t_orders == 0 && st_orders == 0)
            //if (DayOfWeek() == 1 && Hour() > start_hour && Hour() < 8 && t_orders == 0 && st_orders == 0)
            return (weekly_open);
            if(DayOfWeek() == 5 && Hour() > (18 + time_shift) && t_orders >= 0) //&& stop_orders(symbol, magic) == 1)
            //if (DayOfWeek() == 5 && Hour() > 20 && t_orders >= 0) //&& stop_orders(symbol, magic) == 1)
            return(weekly_close);  
            break;            
//-----------------------          
case gap_magic:      
            if(OrderSelect (0, SELECT_BY_POS) && iBarShift (symbol, PERIOD_D1, OrderOpenTime ()) >= 1)
            return (gap_clear);
            if(t_orders == 0 && Hour () == 0)
            return(gap_open);
            break;     
}
return (no_signal);}
//---------------------------------------------------------------------------------------------------------
int stop_orders(string symbol, int mn)
{
   return(calculate_orders(symbol,OP_SELLSTOP, mn) + calculate_orders(symbol, OP_BUYSTOP, mn)); 
}
//---------------------------------------------------------------------------------------------------------
/*int trade_orders(string symbol, int mn)
{
   return (calculate_orders(symbol,OP_SELL, mn) + calculate_orders(symbol, OP_BUY, mn)); 
}*/
//-----------------------,  
int gap_weekly(int mm, string symbol, int magic)
  {
  while(!IsTradeAllowed()) Sleep(100);
   double buy_sl  = NormalizeDouble(Ask-gap_stop*Point, Digits);
   double sell_sl = NormalizeDouble(Bid+gap_stop*Point, Digits);
   int stop = (buy_sl - sell_sl)/Point;
         int count = 0;
         double lot = mm_func(mm, symbol, magic, stop);
         if(lot == 0){
         Print("    - ");
         ts_gap_on = false;
         return (0);         
         }
         
         if(iOpen (symbol, PERIOD_D1, 0) < iLow (symbol, PERIOD_D1, 1))
         {
         while(OrderSend (symbol, OP_BUY, lot, Ask, slippage, buy_sl, 0, comment, magic , 0, CLR_NONE) < 0)
         {
         Sleep(30000); RefreshRates(); count++; if(count > 10) break;}
         count = 0;
         }
         else
         if(iOpen (symbol, PERIOD_D1, 0) > iHigh (symbol, PERIOD_D1, 1))
         {
         while(OrderSend (symbol, OP_SELL, lot, Bid, slippage, sell_sl, 0, comment, magic, 0, CLR_NONE) < 0)
         {
         Sleep(30000); RefreshRates(); count++; if(count > 10) break;}
         count = 0;
         }
   return(0);
  }
//-----------------------,  
int weekly_orders(int mm, string symbol, int magic)
{      
      while(!IsTradeAllowed()) Sleep(100);
      double high = iHigh(symbol,PERIOD_M5,
      iHighest(symbol,PERIOD_M5,MODE_HIGH, (start_hour + time_shift)*16, 0));
      //iHighest(symbol,PERIOD_M5,MODE_HIGH, start_hour*16, 0));
      double low = iLow(symbol,PERIOD_M5, 
      iLowest(symbol,PERIOD_M5,MODE_LOW, (start_hour + time_shift)*16, 0));
      //iLowest(symbol,PERIOD_M5,MODE_LOW, start_hour*16, 0));
      double buy  = NormalizeDouble(high + weekly_enter*Point, Digits);
      double sell = NormalizeDouble(low - weekly_enter*Point, Digits);
      int stop = (buy - sell)/Point;
      int count = 0;
      double lot = mm_func(mm, symbol, magic, stop);
      if(lot == 0){
         Print("    - ");
         ts_weekly_on = false;
         return (0);         
         }
      while(OrderSend(symbol, OP_BUYSTOP,  lot, buy,  slippage, sell , 0,  comment, magic, 0, CLR_NONE) < 0)
           {Sleep(30000); RefreshRates(); count++; if(count > 10) break;}
      count = 0;
      while(OrderSend(symbol, OP_SELLSTOP, lot, sell, slippage, buy ,0, comment, magic, 0, CLR_NONE) < 0)
           {Sleep(30000); RefreshRates(); count++; if(count > 10) break;}      
return (0);
         }
//-----------------------
int set_stop_orders(int mm, string symbol, int magic)
{
      while(!IsTradeAllowed()) Sleep(100);
      double high = iHigh(symbol, PERIOD_H1, 1);
      double low  = iLow(symbol, PERIOD_H1, 1);
      
      //double buy  = high + enter*Point;
      //double sell = low - enter*Point;
      double buy  = NormalizeDouble(high + enter*Point, Digits);
      double sell = NormalizeDouble(low - enter*Point, Digits);
      int stop = (buy - sell)/Point;
      double lot = mm_func(mm, symbol, magic, stop);
     if(lot == 0){
         Print("    - ");
         ts_box_on = false; 
         return (0);         
         }
      int count = 0;
     while(OrderSend(symbol, OP_BUYSTOP, lot, buy,  slippage, sell, 0, comment, magic , 0, CLR_NONE) < 0)
           {Sleep(30000); RefreshRates(); count++; if(count > 5) break;}
     
      count = 0;
     while(OrderSend(symbol, OP_SELLSTOP, lot, sell, slippage, buy, 0, comment, magic , 0, CLR_NONE) < 0)
           {Sleep(30000); RefreshRates(); count++; if(count > 5) break;}
           
return (0);
}//-----------------------,  
int buy_routine(int mm, string symbol, int magic, int sl)
{
     while(!IsTradeAllowed()) Sleep(100);
     int count = 0;
     int i = -1;
     double lot = mm_func(mm, symbol, magic, 35);
     if(lot == 0){
         Print(" RSI  - ");
         ts_rsi_on = false;
         return (0);         
         }
     while(i < 0)
     {
     i = OrderSend(symbol,OP_BUY,lot,Ask,slippage,Ask-sl*Point,0,comment,magic,0,CLR_NONE);
     Sleep(30000); RefreshRates();count++;
     if(count > 5) break;
     } 
return (i);
}
//-----------------------,  
int sell_routine(int mm, string symbol, int magic, int sl)
{
     while(!IsTradeAllowed()) Sleep(100);
     int count = 0;
     int i = -1;
     double lot = mm_func(mm, symbol, magic, 35);
     if(lot == 0){
         Print(" RSI  - ");
         ts_rsi_on = false;
         return (0);         
         }
     while(i < 0)
     {
     i = OrderSend(symbol,OP_SELL,lot,Bid,slippage,Bid+sl*Point,0,comment,magic,0,CLR_NONE);
     Sleep(30000); RefreshRates();count++; 
     if(count > 5) break;
     } 
 
return (i);
}
//+------------------------------------------------------------------+
// MM
//+------------------------------------------------------------------+
double mm_func(int mm_mode, string symbol, int mn, int stop)
{
//+------------------------------------------------------------------+
double lot = 0; 
rebalance(get_balance(mn));
//+------------------------------------------------------------------+
   if(Digits == 5 || Digits == 3)
               {
               stop *= 10;
               }
//---------------------------------------  ,   
virtual_deposit = virtual_balance(symbol, mn, get_rebalance_index(mn));   
//--------------------------------------- 
   switch(mm_mode)
   {
      case mm_math_sqrt: //1
               lot = math_sqrt(virtual_deposit);
               break;
      case mm_percent:  //2
               lot = percent(virtual_deposit);
               break;         
      case mm_martingale: //3
               lot = martingale(virtual_deposit);
               break;          
      case mm_antimartingale: //4
               lot = antimartingale(virtual_deposit);
               break;
      case mm_rajan_jones: //5
               lot = rajan_jones(virtual_deposit, mn);
               break;
      case mm_larry_williams: //6     
               lot = larry_williams(virtual_deposit, 5);
               break;    
      case mm_second_chance: //7
               lot = min_lot;
               break;
      case mm_f2stop: //8 
               lot = quasi_lots(symbol, stop, risk, virtual_deposit);
               break;   
      case mm_test: //9
               //lot = virtual_deposit / ((stop*MarketInfo(symbol, MODE_TICKVALUE)) / risk);
               lot = crazy(virtual_deposit);
               break;   
      default: lot = 0.1;  
               break;   
            }
//+------------------------------------------------------------------+
         double lot_step = MarketInfo(symbol, MODE_LOTSTEP);
         lot = MathRound(lot / lot_step) * lot_step;  
//+------------------------------------------------------------------+
         lot = MathMin(MathMax(lot, min_lot),MarketInfo(symbol,MODE_MAXLOT));
         Comment("     ", mm_names[mm_mode], "\n  : ", symbol, " \n ", ts_name(mn), 
         "  \n  : ", virtual_deposit, " \n  : ", AccountBalance(), 
         " \n  : ", NormalizeDouble(lot, 2));   
//+------------------------------------------------------------------+
         double safe_level = virtual_deposit - margin_to_lot(symbol, lot);
         if(safe_level > 0)
            {
         return(NormalizeDouble(lot, 2));
            }
//+------------------------------------------------------------------+
         else if(safe_level <= 0)
            {
         return(second_chance(symbol, lot, virtual_deposit, mm_mode, mn));
            }
//+------------------------------------------------------------------+
}         
//+------------------------------------------------------------------+         
double second_chance(string symbol, double lot, double deposit, int mm, int mn)
{
//+------------------------------------------------------------------+
         Print("    ,  : (", mm_names[mm], "), : ", symbol);
         Print("      : ", margin_to_lot(symbol, lot));
         Print("  : ", lot);
         Print("   : ", deposit);
//+------------------------------------------------------------------+         
         double temp = AccountBalance() - min_lot*400;
//+------------------------------------------------------------------+
         if(temp <= 0 || mm == mm_second_chance)
                     {
                  Print("   , : ", ts_name(mn),"   : ", deposit);
                  return(0);
                     }
//+------------------------------------------------------------------+
         else if (temp >= 0 && mm != mm_second_chance)
               {
            //start_virtual_balance += margin_to_lot(symbol, MarketInfo(Symbol(), MODE_MINLOT)*3);
            deposit += MathAbs(deposit)+ margin_to_lot(symbol, min_lot*50);
//+------------------------------------------------------------------+
            Print("    ,    50  : ", deposit);
//+------------------------------------------------------------------+                        
      switch (mn)
         {
      case 35:
      //"  ";
      mm_boxes_mode = mm_second_chance;
      break;
      case 50:
      //" RSI";
      mm_rsi_mode = mm_second_chance;
      break;
      case 100:
      //"  ";
      mm_weekly_mode = mm_second_chance;
      break;
      case 115:
      //"  ";
      mm_gap_mode = mm_second_chance;      
      break;
         }
//+------------------------------------------------------------------+
            Print("  : ", ts_name(mn), "    : ", mm_names[mm_second_chance]);
            return(min_lot);
               }
//+------------------------------------------------------------------+
      return(0);
}
//+------------------------------------------------------------------+
double get_balance(int mn)
{
      switch (mn)
         {
      case 35:
      //"  ";
      return (start_virtual_balance[0]);
      break;
      case 50:
      //" RSI";
      return (start_virtual_balance[1]);
      break;
      case 100:
      //"  ";
      return (start_virtual_balance[2]);
      break;
      case 115:
      //"  ";
      return (start_virtual_balance[3]);
      break;
         }
}
//+------------------------------------------------------------------+
void set_balance(int mn, double balance)
{
      switch (mn)
         {
      case 35:
      //"  ";
      start_virtual_balance[0] = balance;
      break;
      case 50:
      //" RSI";
      start_virtual_balance[1] = balance;
      break;
      case 100:
      //"  ";
      start_virtual_balance[2] = balance;
      break;
      case 115:
      //"  ";
      start_virtual_balance[3] = balance;
      break;
         }
}
//+------------------------------------------------------------------+
int get_rebalance_index(int mn)
{
      switch (mn)
         {
      case 35:
      //"  ";
      return (rebalance_index[0]);
      break;
      case 50:
      //" RSI";
      return (rebalance_index[1]);
      break;
      case 100:
      //"  ";
      return (rebalance_index[2]);
      break;
      case 115:
      //"  ";
      return (rebalance_index[3]);
      break;
         }
}
//+------------------------------------------------------------------+
void set_rebalance_index(int mn, int s)
{
      switch (mn)
         {
      case 35:
      //"  ";
      rebalance_index[0] = s;
      break;
      case 50:
      //" RSI";
      rebalance_index[1] = s;
      break;
      case 100:
      //"  ";
      rebalance_index[2] = s;
      break;
      case 115:
      //"  ";
      rebalance_index[3] = s;
      break;
         }
}
//+------------------------------------------------------------------+
double virtual_balance(string symbol, int mn, int seek = 0)
{
double balance = get_balance(mn);
//---------------------------------------
   {
    for (int k = seek; k < OrdersHistoryTotal(); k++)
       {
      OrderSelect (k, SELECT_BY_POS, MODE_HISTORY);
      if(OrderMagicNumber() != mn || OrderSymbol() != symbol) continue;      
      balance += OrderProfit();
       }
   }
return (balance);
}
//+------------------------------------------------------------------+
int count_history(string symbol, int mn)
{
    int t = 0;
    for (int k = 0; k < OrdersHistoryTotal(); k++)
       {
      OrderSelect (k, SELECT_BY_POS, MODE_HISTORY);
      if(OrderMagicNumber() != mn || OrderSymbol() != symbol) continue;      
      t++;
        }
return (t+1);
}
//+------------------------------------------------------------------+
string ts_name(int mn)
{
 string name;
      switch (mn)
         {
      case 35:
      name = "   ";
      break;
      case 50:
      name = "  RSI";
      break;
      case 100:
      name = "   ";
      break;
      case 115:
      name = "   ";
      break;
         }
return (name);
}
//+------------------------------------------------------------------+
double margin_to_lot(string symbol,double lot_to_check)
{
  return (NormalizeDouble(lot_to_check * MarketInfo(symbol,MODE_MARGINREQUIRED),2));
}
//--------------------------------------- 
double math_sqrt(double deposit)
{
 double lot = 0.2 * MathSqrt(deposit/1000); 
 return (lot);               
}               
//--------------------------------------- 
double percent(double deposit)
{
 double lot = virtual_deposit*risk/MarketInfo(Symbol(),MODE_MARGINREQUIRED);//     
  return (lot);               
}               
//--------------------------------------- 
double crazy(double deposit)
  {
   double lot, lastprofit=0,lp1=0,lp2=0;
 
   for(int i=0;i<OrdersHistoryTotal() ;i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)  break;
      lp2=lp1;
      lp1=lastprofit;
      lastprofit=OrderProfit();
   }
   lot=NormalizeDouble(AccountFreeMargin()*risk/1000.0,1);
   if (lastprofit<0 && lp1<0 && lp2<0 ) return(lot);
   return(min_lot);
  }
//--------------------------------------- 
double quasi_lots(string symbol, int stop, double ts_risk, double deposit)
{     
double bet = deposit*ts_risk;
//double pip_price = NormalizeDouble(bet/stop,2);
//double contract_size = NormalizeDouble((pip_price / MarketInfo(symbol, MODE_POINT)/100000),2);
 
double step =MarketInfo(Symbol(),MODE_LOTSTEP);
double stop_value = stop * MarketInfo(Symbol(),MODE_TICKVALUE);
double contract_size = NormalizeDouble(bet/stop_value,2);
contract_size = MathFloor(contract_size/step)*step;
return(contract_size);
}
 
//+------------------------------------------------------------------+
double antimartingale(double deposit)
{
 double lot;
               if(antimartingale_balance > deposit)
               { 
               antimartingale_count --;
               }
               if(antimartingale_balance <=deposit)
               { 
               antimartingale_count ++;
               }     
               lot = antimartingale_count * min_lot;
               antimartingale_balance = deposit;
  return (lot);               
}               
//--------------------------------------- 
double martingale(double deposit)
{
 double lot;
               if (martingale_balance <= deposit)
                     { 
               martingale_count = 1; //min_lot = NormalizeDouble(virtual_deposit/100000,2);
                     }
               if (martingale_balance > deposit)
                     { 
               martingale_count +=martingale_count;
                     }
               lot = martingale_count * min_lot;
               martingale_balance = deposit;
  return (lot);               
}               
//--------------------------------------- rajan_jones ---------------------------------
double rajan_jones(double deposit, int mn)
{
double lot;
//[(     -  )/2]   =   
               while (rajan_jones_level > deposit && rajan_jones_count >= 1)
                  {
               rajan_jones_count --;
               //if (rajan_jones_count <= 1) {rajan_jones_level = start_virtual_balance; lot = min_lot; break;}
               if (rajan_jones_count <= 1) {rajan_jones_level = get_balance(mn); lot = min_lot; break;}
               rajan_jones_level = (((rajan_jones_count * rajan_jones_count - rajan_jones_count)/2) * delta);
                  }
                  
               while (deposit - rajan_jones_level > delta)
                  {
               rajan_jones_count ++;
               rajan_jones_level = (((rajan_jones_count * rajan_jones_count - rajan_jones_count)/2) * delta);
                  }
                  
               lot = min_lot * rajan_jones_count;
   return (lot);
}
//--------------------------------------- LarryWilliams ---------------------------------
double larry_williams(double deposit, double  risk)
{
   return (deposit * (risk / 100) / deposit);
}
//---------------------------------------  ,   
void rebalance(double balance)
{
   if(NormalizeDouble(virtual_deposit/balance, 0) > 3)
   {
   for (int i = 0; i < 4; i++)
      {
   set_rebalance_index(magics[i], count_history(symbol, magics[i]));
   set_balance(magics[i], balance_separator*AccountBalance());
      }
   }
}
//-----------------------
int get_mm_name(int mn)
{
      switch (mn)
         {
      case 35:
      //"   ";
      return (mm_boxes_mode);
      break;
      case 50:
      //"  RSI";
      return (mm_rsi_mode);
      break;
      case 100:
      //"   ";
      return (mm_weekly_mode);
      break;
      case 115:
      //"   ";
      return (mm_gap_mode);
      break;
         }
}
//-----------------------
int info()
{        
         Print("  : ", AccountBalance());
         for(int i = 0; i < 4; i ++)
         {
         int temp = magics[i];
         Print(ts_name(temp) ,",  : ", 
         NormalizeDouble(virtual_balance(symbol, temp, get_rebalance_index(temp)),2),
         " : ", get_rebalance_index(temp),
         "  : ", mm_names[get_mm_name(temp)]);
         }
return(0);
}
//-----------------------    
string error_func(int error){
switch(error) {
            case(0):   return(" ");
            case(1):   return(" ,   ");
            case(2):   return(" ");
            case(3):   return(" ");
            case(4):   return("  ");
            case(5):   return("   ");
            case(6):   return("    ");
            case(7):   return(" ");
            case(8):   return("  ");
            case(9):   return(" ,   ");
            case(64):  return(" ");
            case(65):  return("  ");
            case(128): return("    ");
            case(129): return(" ");
            case(130): return(" ");
            case(131): return(" ");
            case(132): return(" ");
            case(133): return(" ");
            case(134): return("    ");
            case(135): return(" ");
            case(136): return(" ");
            case(137): return(" ");
            case(138): return(" ");
            case(139): return("    ");
            case(140): return("  ");
            case(141): return("  ");
            case(145): return(" , ..     ");
            case(146): return("  ");
            case(147): return("    ");
            case(148): return("      ,  ");
            case(149): return("        ,   ");
            case(150): return("         FIFO");
            case(4000): return("     ");
            case(4001): return("      ");
            case(4002): return("  -  ");
            case(4003): return("    ");
            case(4004): return("    ");
            case(4005): return("      ");
            case(4006): return("    ");
            case(4007): return("    ");
            case(4008): return(" ");
            case(4009): return("   ");
            case(4010): return("    ");
            case(4011): return("  ");
            case(4012): return("    ");
            case(4013): return("  ");
            case(4014): return(" ");
            case(4015): return(" ");
            case(4016): return(" ");
            case(4017): return(" DLL  ");
            case(4018): return("  ");
            case(4019): return("  ");
            case(4020): return("     ");
            case(4021): return("   ,   ");
            case(4022): return(" ");
            case(4050): return("   ");
            case(4051): return("   ");
            case(4052): return("   ");
            case(4053): return(" ");
            case(4054): return("  -");
            case(4055): return("  ");
            case(4056): return(" ");
            case(4057): return("   ");
            case(4058): return("   ");
            case(4059): return("     ");
            case(4060): return("  ");
            case(4061): return("  ");
            case(4062): return("   string");
            case(4063): return("   integer");
            case(4064): return("   double");
            case(4065): return("    ");
            case(4066): return("     ");
            case(4067): return("    ");
            case(4099): return(" ");
            case(4100): return("    ");
            case(4101): return("  ");
            case(4102): return("   ");
            case(4103): return("  ");
            case(4104): return("    ");
            case(4105): return("    ");
            case(4106): return(" ");
            case(4107): return("     ");
            case(4108): return("  ");
            case(4109): return("  .    -*-    -*-   .");
            case(4110): return("   .    .");
            case(4111): return("   .    .");
            case(4200): return("  ");
            case(4201): return("   ");
            case(4202): return("  ");
            case(4203): return("  ");
            case(4204): return("  ");
            case(4205): return("  ");
            case(4206): return("   ");
            case(4207): return("    ");
            default:   return(" "); 
   } 
}


